﻿/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : anonymous_method.cs
Compiler    : Visual Studio 2008
Description : anonymous method by C# 2.0
Release     : 02/12/2011 1.0
*/

using System;
using System.IO;

delegate void display_method(string s); // declare delegate class type

class anonymous_method {
  static void Main(string[] args) {
    Console.WriteLine("1:write to console, 2:write to text");
    int i = Console.Read();
    string s = "Hello World";

    display_method m; // instantiate delegate object m

    if (i == 49)
      m = delegate(string t) { // anonymous method
        Console.WriteLine(t);
      };
    else
      m = delegate(string t) { // anomymous method
        using (StreamWriter sw = new StreamWriter("test.txt"))
          sw.WriteLine(t);
      };

    display_message(m, s);
  }

  static void display_message(display_method m, string s) {
    m(s);
  }
}
